<%--
  Copyright  2005 Obeo.
  All rights reserved.   This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0 or any later version
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
--%>
<%
metamodel http://www.obeo.fr/acceleo/uml14

import org.acceleo.modules.uml14.services.Uml14Services
import org.acceleo.modules.uml14.services.StringServices
%>

<%-- 
This template deals with Struts actions
--%>

<%script type="Class" name="fullFilePath"%>
<%-- Only Classes with stereotype Screen--%>
<%if (hasStereotype("Screen")){%>
/<%scenarioPackage.toPath()%>/<%name%>Servlet.java
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<%-- Generate Struts actions--%>
package <%scenarioPackage%>;

// <%startUserCode%> for import
import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
// <%endUserCode%> for import

/**
 * Implementation of <strong><%name%> Servlet</strong>
 * Scenario : <%namespace.name%>
 *
 */
public class <%name%>Servlet extends HttpServlet {

	private static final long serialVersionUID = 1L;
	
    /**
     * Commons Logging instance.
     */
	private static final Log log = LogFactory.getLog(<%name%>Servlet.class);

    /**
     * Forward codes.
     */
	public final static String PAGE_SELF = "<%namespace.name%>/<%name%>.jsp"; //$NON-NLS-1$
<%-- class association navigation --%>
<%for (association.inverseAssociationEnd()){%><%if (participant.hasStereotype("Screen")){%>
	public final static String PAGE_<%participant.name.toUpperCase()%> = "<%participant.namespace.name%>/<%name%>.jsp"; //$NON-NLS-1$
<%}%><%}%>

<%-- init action method generation (Dispach)--%>
    /**
     * Process the specified HTTP request for event.
     * @param requ The HTTP request we are processing
     * @param resp The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		doAction(req, resp);
	}

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		doAction(req, resp);
	}
	
	protected void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		String event = (String)req.getAttribute("event");
		log.debug("Find event : " + event);
		// <%startUserCode%> before
		// TODO Write here the code to execute before any action of <%name%>Servlet
		// <%endUserCode%>
		
		if ( event == null ) {
			init(req, resp);
		}
		<%for (feature.filter("BehavioralFeature")){%>
		if ("<%name%>".equals(event)) {
			this.<%name%>(req, resp);
		}
		<%}%>
	}
	
    /**
     * Process the specified HTTP request for the initial call to this servlet.
     * @param req The HTTP request we are processing
     * @param resp The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public void init(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		log.debug("Starting <%name%>.init");
		<%for (feature.filter("StructuralFeature")){%>
		String <%name%> = (String)req.getAttribute("<%name%>");
		<%}%>
		String returnCode = PAGE_SELF;
		//<%startUserCode%> init
		// TODO Write here the action code for <%name%>
		//<%endUserCode%>		
		RequestDispatcher dispatcher = req.getRequestDispatcher("/jsp/" + returnCode);
		if (dispatcher != null) {
			dispatcher.forward(req, resp);
		} else {
			throw new ServletException("Redirection failed because " + returnCode + " hasn't been found");
		}
	}

<%-- actions methods generation --%>
<%for (feature.filter("BehavioralFeature")){%>
    /**
     * Process the specified HTTP request for <strong><%name%></strong> event.
     * @param req The HTTP request we are processing
     * @param resp The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public void <%name%>(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		log.debug("Starting <%owner.name%>.<%name%>");
		<%for (owner.feature.filter("StructuralFeature")){%>			
		String <%name%> = (String)req.getAttribute("<%name%>");			
		<%}%>
		//<%startUserCode%> method <%name%>
		String returnCode = PAGE_SELF;
		// TODO Write here the action code for <%name%>
		//<%endUserCode%>		
		RequestDispatcher dispatcher = req.getRequestDispatcher("/jsp/" + returnCode);
		if (dispatcher != null) {
			dispatcher.forward(req, resp);
		} else {
			throw new ServletException("Redirection failed because " + returnCode + " hasn't been found");
		}
	}
<%}%>

	// <%startUserCode%> user methods
	// <%endUserCode%>

}

<%script type="Class" name="scenarioPackage"%>
<%-- ui struts package --%>
org.acceleo.sample.ihm

