package org.acceleo.modules.uml14.services;


import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.ecore.EObject;

import fr.obeo.acceleo.ecore.factories.EFactory;
import fr.obeo.acceleo.ecore.factories.FactoryException;
import fr.obeo.acceleo.gen.template.eval.ENodeCastException;

public class Uml14Services {

	/**
	 * Verify if an Element have a stereotype.
	 * Use keyword and profil to find stereotype. 
	 * Multiple stereotype are allow.
	 * @param elt Element used.
	 * @param stereotype Stereotype to search.
	 * @return true if found. false else.
	 * @throws ENodeCastException
	 */
	public boolean hasStereotype(EObject object, String stereotype) throws ENodeCastException, FactoryException {

		// search with real stereotype
		Iterator it = ((List)EFactory.eGet(object,"stereotype")).iterator();
		while (it.hasNext()) {
			EObject element = (EObject)it.next();
			if (stereotype.equals(EFactory.eGet(element,"name"))){
				return true;
			}
		}
		return false;
}
//	TODO : remove that
//	OLD UML2 service
//	public boolean hasStereotype(Element elt, String stereotype) throws ENodeCastException {
//		// search with real stereotype
//		Stereotype stereotypeFound = elt.getApplicableStereotype(stereotype);
//		if (stereotypeFound == null) {
//			
//			// search with keywords
//			if (elt.hasKeyword(stereotype))
//					return true;
//			
//			return false;
//		}
//		else
//			return true;		
//	}	
	
	/**
	 * Return all classes of specified type contained inside a package (or a model).
	 * Use a deep search.
	 * @param package
	 * @return all classes
	 */
//	public Collection getAllClasses(Package pack) {
//		Collection classes = new ArrayList();
//		classes.addAll(pack.getOwnedTypes());
//		Collection innerPackCol = pack.getNestedPackages();
//		for (Iterator iter = innerPackCol.iterator(); iter.hasNext();) {
//			Package innerPack = (Package) iter.next();
//			classes.addAll(getAllClasses(innerPack));
//		}
//		return classes;
//	}
	
	
	
	public EObject inverseAssociationEnd(EObject object) throws FactoryException {
		EObject end = (EObject)object;
		Iterator it = ((List)EFactory.eGet((EObject)EFactory.eGet(object,"association"),"connection")).iterator();
		while (it.hasNext()) {
			EObject result = (EObject)it.next();
			if (result != end){
				return result;
			}
		}
		return null;
	}
}
